Bug 1980282 - Review Request: exaile - music player
Summary: Review Request: exaile - music player
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-07-08 09:04 UTC by Graham White
Modified: 2021-07-22 01:15 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-07-22 01:13:44 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Graham White 2021-07-08 09:04:17 UTC
Spec URL: https://grahamwhiteuk.fedorapeople.org/pkgreviews/exaile/exaile.spec
SRPM URL: https://grahamwhiteuk.fedorapeople.org/pkgreviews/exaile/
Fedora Account System Username: grahamwhiteuk

Description:
I would like to bring back and maintain the orphaned exaile package.  Exaile is a GTK based music player written in Python and was included in Fedora up to F31 at which point it was orphaned.  I suspect it was orphaned because at that time Exaile was still based on Python 2 and so the timing between Fedora dropping Python 2 support and Exaile supporting Python 3 didn't match up [1].

I have contacted the previous maintainers [2], Christopher and Deji, to ask whether they intend to continue maintenance and if they mind me taking over the package.  Christopher responded to say he has left the community and I've not yet received a response from Deji.

I have also checked upstream [3] that the developers are happy for it to be re-included in Fedora.

To build the latest packages, I started from the latest exaile.spec file [4] most recently built for F31 and have made as few modifications as possible to add support for Python 3 and update the dependencies to the required levels.  I've been running the package on my own Fedora 34 system for a couple of months (since April) and it's working very well.

Note: I'm following the "New Package Process for Existing Contributors" [5] guide as I'm not aware of any instructions specific to bringing back a previously orphaned package.

[1] https://fedoraproject.org/wiki/Changes/RetirePython2
[2] https://src.fedoraproject.org/rpms/exaile
[3] https://groups.google.com/g/exaile-devel/c/uUfDcTatuZs
[4] https://src.fedoraproject.org/rpms/exaile/blob/f31/f/exaile.spec
[5] https://fedoraproject.org/wiki/New_package_process_for_existing_contributors

Comment 1 Ben Beasley 2021-07-08 13:41:52 UTC
You’re on the right track. Here are the official instructions for what you’re trying to do: https://fedoraproject.org/wiki/Orphaned_package_that_need_new_maintainers#Claiming_Ownership_of_a_Retired_Package

Comment 2 Graham White 2021-07-08 13:51:30 UTC
Fantastic, thanks Ben.  I'll give that a whirl but leave this bug open while I'm attempting to claim ownership.

Comment 3 Ben Beasley 2021-07-08 13:53:35 UTC
This review is part of the process anyway… I can’t do the review right now but might take a look at it later if I have some time.

Comment 4 Graham White 2021-07-08 14:09:06 UTC
OK, so looking around on the devel list, Exaile was orphaned/retired because of Python 2 as I had originally suspected [1].  There's also a bug report for having it obsoleted [2].

I've moved over to following the Claiming Ownership of a Retired Package procedure and have mail the devel list [3].

[1] https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/SYBEPMFAEZCCHQE6SM2SDXXUV6S73HGI/
[2] https://bugzilla.redhat.com/show_bug.cgi?id=1810253
[3] https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/5RV2LRDPW4Y23VG74LQSDBVWEOEUZC7D/

Comment 5 Robert-André Mauchin 🐧 2021-07-08 19:16:24 UTC
 - You need to set Fedora default build flags:

%build
%set_build_flags
%make_build

 - You could try to keep timestamps by changing install -m to $(INSTALL) -m
 - and also use the auto rpm script "brp-python-bytecompile" to compile all the pyc files by disabling compile in the Makefile

# Keep timestamps while installing
# Delegate pyc compilation to brp-python-bytecompile
sed -i "s|install -m|\$(INSTALL) -m|;s|all: compile |all: |" Makefile

 - Why no tests? Steps because it's tricky:

Source0:        https://github.com/exaile/exaile/archive/%{version}/%{name}-%{version}.tar.gz
# Fix for bug https://github.com/exaile/exaile/issues/750
Patch0:         https://github.com/exaile/exaile/commit/d8bbcfd174b658babb6605799d1e9e788b578c84.patch

[…]

BuildRequires:  cairo-gobject
BuildRequires:  desktop-file-utils
BuildRequires:  gettext
BuildRequires:  gobject-introspection
BuildRequires:  gstreamer1-plugins-base >= 1.14
BuildRequires:  gstreamer1-plugins-good >= 1.14
BuildRequires:  gtk3 >= 3.22
BuildRequires:  help2man
BuildRequires:  libappstream-glib
BuildRequires:  python3-bsddb3
BuildRequires:  python3-cairo
BuildRequires:  python3-dbus
BuildRequires:  python3-devel
BuildRequires:  python3-gobject-devel >= 3.22
BuildRequires:  python3-gstreamer1 >= 1.14
BuildRequires:  python3-mox3
BuildRequires:  python3-mutagen >= 1.38
BuildRequires:  python3-pytest
BuildRequires:  python3-setproctitle

[…]

%prep
%autosetup -p1

[…]

%check
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/appdata/*.appdata.xml
make test

 - Remove the shebang from these files:

exaile.noarch: E: non-executable-script /usr/share/exaile/plugins/bpm/bpmdetect.py 644 /usr/bin/env python3
exaile.noarch: E: non-executable-script /usr/share/exaile/plugins/ipconsole/ipython_view.py 644 /usr/bin/env python3

See https://fedoraproject.org/wiki/Packaging_tricks#Remove_shebang_from_Python_libraries

 - Patch the old addresses with the new address and send the patch upstream:

exaile.noarch: E: incorrect-fsf-address /usr/share/exaile/plugins/lyricsmania/__init__.py
exaile.noarch: E: incorrect-fsf-address /usr/share/exaile/plugins/somafm/__init__.py



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review neede


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GNU General Public License, Version 2", "Unknown or
     generated", "GNU General Public License v2.0 or later", "GNU General
     Public License v1.0 or later", "*No copyright* GNU General Public
     License v2.0 or later", "GNU General Public License v3.0 or later",
     "*No copyright* GNU General Public License v1.0 or later", "BSD
     3-clause "New" or "Revised" License", "*No copyright* GNU General
     Public License v3.0 or later", "GNU General Public License v2.0 or
     later [obsolete FSF postal address (Mass Ave)]", "*No copyright* GNU
     General Public License", "GNU Lesser General Public License v2.1 or
     later". 407 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/exaile/review-
     exaile/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: exaile-4.1.1-1.fc35.noarch.rpm
          exaile-4.1.1-1.fc35.src.rpm
exaile.noarch: W: spelling-error %description -l en_US playlists -> play lists, play-lists, stylists
exaile.noarch: W: spelling-error %description -l en_US fm -> FM, Fm, gm
exaile.noarch: W: spelling-error %description -l en_US scrobbling -> scribbling, scrabbling, scrolling
exaile.noarch: E: non-executable-script /usr/share/exaile/plugins/bpm/bpmdetect.py 644 /usr/bin/env python3
exaile.noarch: E: non-executable-script /usr/share/exaile/plugins/ipconsole/ipython_view.py 644 /usr/bin/env python3
exaile.noarch: E: incorrect-fsf-address /usr/share/exaile/plugins/lyricsmania/__init__.py
exaile.noarch: E: incorrect-fsf-address /usr/share/exaile/plugins/somafm/__init__.py
exaile.src: W: spelling-error %description -l en_US playlists -> play lists, play-lists, stylists
exaile.src: W: spelling-error %description -l en_US fm -> FM, Fm, gm
exaile.src: W: spelling-error %description -l en_US scrobbling -> scribbling, scrabbling, scrolling
exaile.src: W: spelling-error %description -l en_US podcasts -> podcast, pod casts, pod-casts
exaile.src: W: spelling-error %description -l en_US icecast -> ice cast, ice-cast, icecap
2 packages and 0 specfiles checked; 4 errors, 8 warnings.

Comment 6 Graham White 2021-07-09 10:36:26 UTC
Thanks for taking the time to do the review and all your extra detail, that was all extremely helpful.

I have updated the spec file and built a new set of RPMS, all uploaded to https://grahamwhiteuk.fedorapeople.org/pkgreviews/exaile/

I have also submitted 3 patches upstream:
1) https://github.com/exaile/exaile/pull/759 - Preserve timestamp upon file installation.
2) https://github.com/exaile/exaile/pull/760 - Use the correct address for the FSF
3) https://github.com/exaile/exaile/pull/761 - Remove shebangs from plugins installed without execute perms

Changes made are:

* Set Fedora default build flags
 - added %set_build_flags to the %build section

* Keep timestamps and defer byte compilation to brp-python-bytecompile
 - spec file modifies the Makefile to add -p flag to install command (this aspect will be remove if PR 759 is accepted upstream)
 - spec file modifies the Makefile to remove the compilation step

* Re-enabled tests, I've no idea why this was disabled by the previous packagers
 - patch d8bbcfd174b658babb6605799d1e9e788b578c84 incorporated to facilitate successful tests until next upstream release (where the patch has been merged upstream)

* Updated BuildRequires
 - as indicated in the above package review and to include additional BRs to allow the tests to execute

* Correct rpmlint issues
 - patch submitted upstream to use the correct FSF address
 - patch submitted upstream to remove unnecessary shebangs

@zebob.m@gmail.com - I wonder if you would be kind enough to double check with an updated review?

Thanks again.

Comment 7 Robert-André Mauchin 🐧 2021-07-10 09:01:02 UTC
LGTM, package approved.

Comment 8 Graham White 2021-07-10 14:55:05 UTC
Following the process [1], the next step is a releng ticket [2].

[1] https://fedoraproject.org/wiki/Orphaned_package_that_need_new_maintainers#Claiming_Ownership_of_a_Retired_Package
[2] https://pagure.io/releng/issue/10206

Comment 9 Fedora Update System 2021-07-13 07:33:18 UTC
FEDORA-2021-f569edcb75 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-f569edcb75

Comment 10 Fedora Update System 2021-07-13 07:38:33 UTC
FEDORA-2021-230656804f has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-230656804f

Comment 11 Fedora Update System 2021-07-14 01:01:11 UTC
FEDORA-2021-f569edcb75 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-f569edcb75 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-f569edcb75

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-07-14 01:10:17 UTC
FEDORA-2021-230656804f has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-230656804f \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-230656804f

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2021-07-22 01:13:44 UTC
FEDORA-2021-f569edcb75 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 14 Fedora Update System 2021-07-22 01:15:56 UTC
FEDORA-2021-230656804f has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.